#!/bin/sh
set -x

host=client
ip netns exec ${host} tc qdisc replace dev ${host}.l root pfifo

# server

host=server
ip netns exec ${host} tc qdisc replace dev ${host}.r root pfifo

# delay

host=delay
ip netns exec ${host} tc qdisc del dev ${host}.l root
ip netns exec ${host} tc qdisc del dev ${host}.r root
ip netns exec ${host} tc qdisc replace dev ${host}.l root handle 1:0 netem delay 50ms limit 100000
ip netns exec ${host} tc qdisc replace dev ${host}.r root handle 1:0 netem delay 50ms limit 100000

# middlebox

host=isp
ip netns exec ${host} tc qdisc del dev ${host}.l root
ip netns exec ${host} tc qdisc del dev ${host}.r root
ip netns exec ${host} tc qdisc replace dev ${host}.l root handle 1:0 netem rate 900mbit limit 100000
ip netns exec ${host} tc qdisc replace dev ${host}.r root handle 1:0 netem rate 900mbit limit 100000
ip netns exec ${host} tc qdisc replace dev ${host}.r parent 1:1 handle 10:1 bfifo limit 1024k

host=mbox
ip netns exec ${host} tc qdisc del dev ${host}.l root
ip netns exec ${host} tc qdisc del dev ${host}.r root
ip netns exec ${host} tc qdisc replace dev ${host}.l root handle 1:0 cake bandwidth 810mbit 
ip netns exec ${host} tc qdisc replace dev ${host}.r root handle 1:0 cake bandwidth 810mbit 
# let me ping localhost

#. ./settings.example

for host in $HOSTS
do
ip netns exec ${host} ifconfig lo up
ip netns exec ${host} sysctl -w net.ipv4.tcp_ecn=2
done
