#!/bin/bash

# Create the bridge
#ip link add br2 type bridge

# Create network namespaces and veth interfaces
# TOPOLOGY server - delay - mbox - client

for host in $HOSTS ; do
    ip netns add ${host}
done

ip link add server.r type veth peer name delay.l
ip link add delay.r type veth peer name isp.l
ip link add isp.r type veth peer name mbox.l
ip link add mbox.r type veth peer name client.l

ip link set dev server.r netns server
ip link set dev delay.r netns delay
ip link set dev delay.l netns delay
ip link set dev mbox.l netns mbox
ip link set dev mbox.r netns mbox
ip link set dev isp.l netns isp
ip link set dev isp.r netns isp
ip link set dev client.l netns client

ip netns exec server ip link set server.r up
ip netns exec delay ip link set delay.r up
ip netns exec delay ip link set delay.l up
ip netns exec isp ip link set isp.r up
ip netns exec isp ip link set isp.l up
ip netns exec mbox ip link set mbox.r up
ip netns exec mbox ip link set mbox.l up
ip netns exec client ip link set client.l up

# Assign IPs
#ip addr add 10.10.10.254/24 dev br2

ip netns exec server ip addr add 10.10.0.1/24 dev server.r
ip netns exec server ip -6 addr add fc00::1/64 dev server.r

ip netns exec delay ip addr add 10.10.0.2/24 dev delay.l
ip netns exec delay ip -6 addr add fc00::2/64 dev delay.l
ip netns exec delay ip addr add 10.10.1.1/24 dev delay.r
ip netns exec delay ip -6 addr add fc01::1/64 dev delay.r

ip netns exec isp ip addr add 10.10.1.2/24 dev isp.l
ip netns exec isp ip -6 addr add fc01::2/64 dev isp.l
ip netns exec isp ip addr add 10.10.2.1/24 dev isp.r
ip netns exec isp ip -6 addr add fc02::1/64 dev isp.r

ip netns exec mbox ip addr add 10.10.2.2/24 dev mbox.l
ip netns exec mbox ip -6 addr add fc02::2/64 dev mbox.l
ip netns exec mbox ip addr add 10.10.3.1/24 dev mbox.r
ip netns exec mbox ip -6 addr add fc03::1/64 dev mbox.r

ip netns exec client ip addr add 10.10.3.2/24 dev client.l
ip netns exec client ip -6 addr add fc03::2/64 dev client.l

