#!/bin/sh

set -x

host=client
ip netns exec ${host} tc qdisc add dev ${host}.l root fq_codel
ip netns exec ${host} ip route add default via 10.10.3.1 dev ${host}.l
ip netns exec ${host} ip -6 route add default via fc03::1 dev ${host}.l

# server

host=server
ip netns exec ${host} tc qdisc add dev ${host}.r root fq
ip netns exec ${host} ip route add default via 10.10.0.2 dev ${host}.r
ip netns exec ${host} ip route add default via fc00::2 dev ${host}.r

# delay

host=delay

ip netns exec ${host} ip route add 10.10.2.0/24 via 10.10.1.2
ip netns exec ${host} ip route add 10.10.3.0/24 via 10.10.1.2
ip netns exec ${host} ip route add default via 10.10.0.1 dev ${host}.l
ip netns exec ${host} ip -6 route add fc02::/64 via fc01::2
ip netns exec ${host} ip -6 route add fc03::/64 via fc01::2
ip netns exec ${host} ip -6 route add default via fc00::1 dev ${host}.l

ip netns exec ${host} tc qdisc add dev ${host}.r root netem delay 10ms
ip netns exec ${host} tc qdisc add dev ${host}.l root netem delay 10ms

# middlebox

host=isp
ip netns exec ${host} ip route add 10.10.0.0/24 via 10.10.1.1
ip netns exec ${host} ip route add 10.10.3.0/24 via 10.10.2.2
ip netns exec ${host} ip -6 route add fc00::/64 via fc01::1
ip netns exec ${host} ip -6 route add fc03::/64 via fc02::2
ip netns exec ${host} tc qdisc add dev ${host}.r root netem rate 15mbit
ip netns exec ${host} tc qdisc add dev ${host}.l root netem rate 1mbit


host=mbox
ip netns exec ${host} ip route add 10.10.1.0/24 via 10.10.2.1
ip netns exec ${host} ip route add 10.10.0.0/24 via 10.10.2.1
ip netns exec ${host} ip -6 route add fc01::/64 via fc02::1
ip netns exec ${host} ip -6 route add fc00::/64 via fc02::1
ip netns exec ${host} tc qdisc add dev ${host}.r root netem rate 15mbit
ip netns exec ${host} tc qdisc add dev ${host}.l root netem rate 1mbit

# let me ping localhost

for host in $HOSTS
do
ip netns exec ${host} ifconfig lo up
done
